让APK只包含指定的ABI

        现在很多android第三方 sdk是以aar形式提供的,甚至是远程aar,如果这个sdk对abi的支持比较全,可能会包含armeabi, armeabi-v7a,x86, arm64-v8a,x86_64五种abi,而你应用的其它so只支持armeabi,armeabi-v7a,x86三种,直接引用sdk的aar,会自动编译出支持5种abi的包。

       但是应用的其它so缺少对其它两种abi的支持,那么如果应用运行于arm64-v8a,x86_64为首选abi的设备上时,就会CRASH

       怎么解决这个问题?其实arm64-v8a,x86_64这两个abi应用并不是必须要做支持,手机一般都会提供自动兼容,像微信就是一个armeabi打天下。

       所以我们只要把对x86, arm64-v8a,x86_64的支持去掉就可以。怎么去呢,之前想了一个比较笨的办法,就是写个脚本直接把lib目录下对应的abi文件夹删掉再重新签名。

       后来找到两个更方便的办法

一、需要在build.gradle的android里添加如下内容:

productFlavors {
    necess {
        ndk {
            abiFilters "armeabi-v7a"
            abiFilters "x86"
            abiFilters "armeabi"
        }
    }
    abiall {
        ndk {
            abiFilters "armeabi-v7a"
            abiFilters "x86"
            abiFilters "armeabi"
            abiFilters "arm64-v8a"
            abiFilters "x86_64"
        }
    }
}
生成apk的界面如下图:

会分别生成app-abiall-release.apk和app-necess-release.apk

如果本来有做渠道包支持,只要添加对应的ndk.abiFilters即可,原理就是设置不同的渠道包指定不同的指令集

二、使用全局设置,这种方法对一般需求来说可能更为实用

        build.gradle的android里的defaultConfig内添加如下内容:

    defaultConfig {
        ndk {
            abiFilters "armeabi", "armeabi-v7a", "x86"
        }
    }
然后所有渠道包都会顶多包含此三种指令集


阅读更多
想对作者说点什么?

博主推荐

换一批

没有更多推荐了,返回首页